function fxDtsBrick::shiftRegion(%brick, %becomes, %time, %vect, %cl)
{
	%vect = getWords(vectorScale(%vect, 0.5), 0, 1) SPC (getWord(%vect, 2) / 5);
	//We assume any client able to press the control brick has had their region set
	if(!isObject(%pl = %cl.player) || (%region = %pl.region) $= "")
		return;   //If not, we don't want to act upon their influence.
	shiftRegionTimer(%time, getWord(%vect, 1) + 0, getWord(%vect, 0) + 0, getWord(%vect, 2) + 0, %region, %becomes, "Time to arrival: [TIME]", %brick, %cl);
}

function fxDtsBrick::shiftRegion_V2(%brick, %vect, %time, %becomes, %message, %cl)
{
	%vect = getWords(vectorScale(%vect, 0.5), 0, 1) SPC (getWord(%vect, 2) / 5);
	//We assume any client able to press the control brick has had their region set
	if(!isObject(%pl = %cl.player) || (%region = %pl.region) $= "")
		return;   //If not, we don't want to act upon their influence.
	shiftRegionTimer(%time, getWord(%vect, 1) + 0, getWord(%vect, 0) + 0, getWord(%vect, 2) + 0, %region, %becomes, %message, %brick, %cl);
}

function Player::setRegion(%pl, %region, %cl)
{
	%pl.region = %region;
	if(!isObject(RegionObjects))
		new SimGroup(RegionObjects);
	RegionObjects.add(%pl);
}

function Player::clearRegion(%pl, %cl)
{
	%pl.region = "";
	if(isObject(RegionObjects) && RegionObjects.isMember(%pl))
		RegionObjects.remove(%pl);
}

function shiftRegionTimer(%time, %x, %y, %z, %region, %becomes, %msg, %brick, %cl)
{
	if(%time == 0)
	{
		%add = %x SPC %y SPC %z;
		for(%i=0;%i<RegionObjects.getCount();%i++)
		{
			if(isObject(%this = RegionObjects.getObject(%i)) && (%this.region $= %region))
			{
				%this.region = %becomes;
				%this.setTransform(vectorAdd(getWords(%this.position, 0, 2), %add) SPC getWords(%this.getTransform(), 3, 6));
				if(isObject(%this.client) && %msg !$= "")
					%this.client.centerPrint("\c6You have arrived at your destination.", 3);
			}
			%brick.processInputEvent("onRegionShift", %cl);
		}
	}
	else
	{
		for(%i=0;%i<RegionObjects.getCount();%i++)
			if(isObject(%this = RegionObjects.getObject(%i)) && (%this.region $= %region) && isObject(%this.client))
				%this.client.centerPrint("\c6"@strReplace(strReplace(%msg, "[TIME]", convertToHMS(%time)), "[NAME]", %this.client.name), 3);
		schedule(1000, 0, "shiftRegionTimer", %time--, %x, %y, %z, %region, %becomes, %msg, %brick, %cl);
	}
}

function convertToHMS(%seconds)
{
	if(%time < 0)
		return 0;
	else if(%time > 36000)
		return "10:00:00";   //Seriously, who needs a timer that goes up that far?
	while(%seconds >= 60)
	{
		%seconds -= 60;
		%minutes++;
	}
	while(%minutes >= 60)
	{
		%minutes -= 60;
		%hours++;
	}
	if(%hours != 0)
	{
		if(strLen(%minutes) == 1)
			%minutes = "0"@%minutes;
		if(strLen(%seconds) == 1)
			%seconds = "0"@%seconds;
		return %hours@":"@%minutes@":"@%seconds;
	}
	else if(%minutes != 0)
	{
		if(strLen(%seconds) == 1)
			%seconds = "0"@%seconds;
		return %minutes@":"@%seconds;
	}
	else
		return %seconds;
}

exec("./Events.cs");